
//	EXEDRV32.H
//	(C)IRAI
//	Mise  jour le 05/11/97 par Alain



#pragma pack(1)	//	Alignement


// *********************************************************************************************
// Structure uniquement ncessaire aux drivers.
// renseigne le code de la librairie sur la table de structures de donnes globales fonction
// du type de driver 
typedef struct
	{
	WORD	wPrivateDataSize;		// Taille d'une structure de donnes globale
	WORD	wOffsetDrvNum;			// Donne l'offset de DrvNum dans la struct PRIVATE_DATA
	WORD	wMaxPseudoInstance;		// Nombre de postes de la tables de structures
	char	*pszHelFileName;		// Pointeur recoit le nom "X.HLP" (HELP_FILE) le nom complet se retrouvera dans szHelpFile
	}INFO_PRIVATEDATA;



// *********************************************************************************************
// Liste des routines appeles par la librairie EXEDRV32.LIB  implmenter dans un driver
// *********************************************************************************************

// Initialisation du driver (pointeur sur sa structure de variables globales)
int drv_init(void *pPrivateData);

// Dsinitialisation du driver (pointeur sur sa structure de variables globales)
int drv_uninit(void *pPrivateData);

// Mise  0 des sorties (pointeur sur sa structure de variables globales)
int drv_reset(void *pPrivateData);

//	Rafrachissement du WD (pointeur sur sa structure de variables globales)
int drv_watchdog(void *pPrivateData);

//	Lecture des entres (pointeur sur sa structure de variables globales)
int drv_input(void *pPrivateData);

//	Ecriture des sorties (pointeur sur sa structure de variables globales)
int drv_output(void *pPrivateData);

//	Lecture des entres mode asynchrone instruction RIN (pointeur sur sa structure de variables globales)
int drv_rin(void *pPrivateData);

//	Ecriture des sorties mode asynchrone instruction WOU (pointeur sur sa structure de variables globales)
int drv_wou(void *pPrivateData);

//  Eventuelles allocations et documentation des valeurs de rglages par dfaut (pointeur sur sa structure de variables globales)
int drv_create(void *pPrivateData);

//	Dsinitialisation du driver (handle de fentre,pointeur sur tableau[3] de structures de variables globales)
//	L'exemplaire [0] est celui qui est utilis par tous les autres points d'entres
//	Utile pour Editer/Appliquer/Annuler
int drv_config(HWND hwnd,LPARAM pNewOldData,DWORD NumDrv);

//	Ecriture des rglages du driver dans le fichier courant .INI ou .SET (pointeur sur sa structure de variables globales)
int drv_save(void *pPrivateData);

//  Eventuelles allocations mmoire et lecture du .SET (pointeur sur sa structure de variables globales)
int drv_build(void *pPrivateData);

//  Dsallocation ventuelle de mmoire (pointeur sur sa structure de variables globales)
int drv_destroy(void *pPrivateData);

//  Renseigne la librairie sur la taille de la structure des donnes globales, sur le nombre de postes
//	du tableau de structure et sur le nom du fichier d'aide.
void *drv_PrivateDataInfo(INFO_PRIVATEDATA *gInfo_privatedata);

// *********************************************************************************************
// Fin de la liste des routines appeles par la librairie EXEDRV32.LIB  implmenter dans un driver
// *********************************************************************************************




// *********************************************************************************************
// Liste des routines de librairie EXEDRV32.LIB utilisables par un driver
// *********************************************************************************************

// Contrle de la validit d'un numro de variable
// (1re var, nombre de variables utilises, type de variable)
BOOL ValidNumVar(WORD num,WORD used,int type);

// Lecture d'un entier depuis une ligne d'un .INI
int get_ini_int(char *cDrvLine,int *iVar,int iDefault);

// Ecriture d'un entier dans une ligne d'un .INI
int write_ini_int(char *pcKey,DWORD dNumDrv,int iVar);


// Lire 1 octet sur IO
int inport_b(DWORD port,BYTE *val);
// Lire n octets sur IO
int inport_buff(DWORD port,BYTE *val,DWORD len);

// Ecrire 1 octet sur IO
int outport_b(DWORD port,BYTE val);
// Ecrire n octets sur IO
int outport_buff(DWORD port,BYTE *val,DWORD len);

// Appel d'une routine d'E/S en mode Kernel en passant :
// l'adresse de la routine et ladresse de la structure de type PRIVATE_DATA
// callKmode(ma_routine,ma_structure);
int callKmode(int (*KModeEntry)(void *),ULONG myArgs);

//	Fonctions non untilisables
int setKmode(void);			//
int releaseKmode(void);		//
//	--------------------------

// *********************************************************************************************
// Fin de la liste des routines de librairie EXEDRV32.LIB utilisables par un driver
// *********************************************************************************************


// Fin de EXEDRV32.H
