
//	EXEC_DRV.H
//	(C)IRAI
//	Mise  jour le 05/11/97 par Alain


#pragma pack (1)		// Alignement  1 octet



// *********************************************************************************************

//		Dfinitions qui sont utilises par EXECPC32 et par les drivers (.DIO)

// *********************************************************************************************


#define DRV_INIT	0		// Init des priph, Open stream ...
#define DRV_UNINIT	1		// Close stream

#define DRV_RESET	2		// Reset de sorties
#define DRV_INPUT	3		// Les entres et dans la foule, le WatchDog
#define DRV_OUTPUT	4		// Ecrire les sorties
#define DRV_RIN		5		// Entres et
#define	DRV_WOU		6		// Sorties par RIN et WOU en cours de cycle (option)


#define DRV_CREATE	0XFFFB	// Appel lors de l'ajout d'un DRV : alloue mais ne lit pas le .INI
#define DRV_SAVE	0XFFFC	// Ecriture .INI
#define DRV_CONFIG	0XFFFD	// Modif paramtres
#define DRV_BUILD	0XFFFE	// Lecture .INI au cours de la confection des donnes des drivers
							// (allouer la mmoire donnes spcifiques
#define DRV_DESTROY	0XFFFF	// Destruction du driver desallocation si ncessaire de la mmoire des donnes 
							// qui aurait t alloue.



#define INP_TYPE	0		// Entres
#define OUT_TYPE	1
#define BIT_TYPE	2
#define WORD_TYPE	4
#define COUNT_TYPE	5
#define FLOAT_TYPE	6
#define	LONG_TYPE	7		// Les longs


// Compte rendu par le driver
#define DRV_ERR2	-2		// Do not use : internal
#define DRV_ERR		-1		// A retourner en cas d'erreur
#define DRV_NOMODIF	0		// Lors d'une demande de paramtrage annule
#define DRV_MODIF	1		// Lors d'une demande de paramtrage effectue et applique


// Type de services offerts par le noyau (dans IO32.H) aux drivers par
// l'intermediaire de EXEDRV32.LIB
#define INPORTB			0	// Lire 1 octet sur IO
#define INPORTBUFF		2	// Lire n octets sur IO
#define OUTPORTB		1	// Ecrire 1 octet sur IO
#define OUTPORTBUFF		3	// Ecrire n octets sur IO
#define INMEMBUFF		4
#define OUTMEMBUFF		5
#define CALLKMODE		6	// Appel d'une routine de driver sous le mode Kernel
#define SETKMODE		7	// Basculer en mode Kernel			NON IPLEMENTE	
#define RELEASEKMODE	8	// Basculer de Kernel en mode User	NON IMPLEMENTE


// Mots cls standards dans la section [execpc32_drvio] dans AUTOMGEN.INI ou APPLIC.SET

#define INI_DRV_SECTION		"execpc32_drvio"	// La section
#define INI_DRV_NBDRV		"execpc32_drvnb"	// Le nombre de drivers
#define INI_DRV_NAME		"execpc32_drvname_"	// Le nom du driver
#define INI_DRV_NUM_INPUT	"execpc32_input_"	// Le nombre de variables
#define INI_DRV_NUM_OUTPUT	"execpc32_output_"	// de chaque type
#define INI_DRV_NUM_BIT		"execpc32_bit_"		// qu'il utilise
#define INI_DRV_NUM_WORD	"execpc32_word_"
#define INI_DRV_NUM_COUNT	"execpc32_count_"
#define INI_DRV_NUM_FLOAT	"execpc32_float_"
#define INI_DRV_NUM_LONG	"execpc32_long_"
#define INI_DRV_NUM_ISR		"execpc32_isr_"





// Structure de variables de contexte applicatif et excutif ncessaire aux drivers
// Cette structure est utilise par le systme d'excution et doit tre connue des drivers (.DIO)

typedef struct
	{
	BYTE	*adrvari;		// Adresse variables entres
	BYTE	*adrvaro;		// Adresse variables sorties
	BYTE	*adrvarb;		// Adresse variables bits
	BYTE	*adretat;		// Adresse variables etats temporisations
	WORD	*adrvart;		// Adresse compteurs/consignes temporisation
	WORD	*adrvarm;		// Adresse variables mots
	WORD	*adrvarc;		// Adresse variables compteurs
	DWORD	*adrvarl;		// Adresse longs
	float	*adrvarf;		// Adresse floats

	WORD	nbinput;		// Nombre d'entres
	WORD	nboutput;		// Nombre de sorties
	WORD	nbbit;			// Nombre de bits
	WORD	nbtempo;		// Nombre de temporisations
	WORD	nbword;			// Nombre de mots
	WORD	nbcount;		// Nombre de compteurs
	WORD	nbfloat;		// Nombre de floats
	WORD	nblong;			// Nombre de longs
	
	// pointeur sur fonction de positionnement d'une variable boolenne
	BYTE *(*ptr_in1var)(BYTE *adresse,BYTE etat);
		// Pointeur sur fonction de positionnement de 8 variables boolennes
	BYTE *(*ptr_in8var)(BYTE *adresse,BYTE etat);
	// Pointeur sur fonction d'acquisition d'une variable boolenne
	BYTE *(*ptr_out1var)(BYTE *adresse,BYTE *etat);
	// Pointeur sur fonction d'acquisition de 8 variables boolennes
	BYTE *(*ptr_out8var)(BYTE *adresse,BYTE *etat);
	// Pointeur sur gestionnaire de fonctions utilisateur appeles de faon asynchrone (#In)
	void (*ptr_isrtask)(WORD numint);
	// Pointeur sur fonctions d'E/S spcifiques au hard contenues dans le noyau  usage des drivers
	DWORD (*ptr_io_routine)(DWORD fonction,DWORD *pinp,DWORD *pout,DWORD len);

	LPVOID	ptr_system;		// Pointeur sur la structure systme APP_SYSTEM
	
	BYTE	timer;			// TIMER SYSTEME
	BYTE	run_stop;		// 0 -> STOP, 1 -> INIT,  2 -> RUN et 3 -> APP_DESTROY
	BOOL	fApp_ok;		// TRUE = programme prsent

	BYTE	bFutureUse[20];	// Destin au systme
	LPVOID	lpExtra;		// Extra au cas ou ...
	WORD accessright;
	}APP_CONTEXT;



// *********************************************************************************************
//		Fin de la zone utilise pour la conception de drivers (.DIO)
// *********************************************************************************************








// *********************************************************************************************
//	Dfinitions qui sont utilises par EXECPC32 et la librairie EXEDRV32.LIB
// *********************************************************************************************


// Structure documente par :
// - Le systme,
// - Le driver dans EXEDRV32.LIB


// Et exploite par :
// - Le systme lors de la configuration des drivers,
// - Les drivers (.DIO) dans EXEDRV32.LIB lors de chaque appel par int drv_inout(numfonc)

typedef struct
	{
	char	drv_name[256];	// Nom du driver (.DIO)
	HMODULE hmodule;		// Handle de la dll (.DIO)
	DWORD	PseudoInstance;	// Repre le N d'invocation de la dll (.DIO) par un unique process
	int (*dllentry)(DWORD numdrv,WORD fonction,APP_CONTEXT *simul_app_context,LPVOID driver_data,char *ini_name);
	}DRIVER_DATA;


//-----------------------------------------------------------------------------
// Fin
