//	EXEDRV32.C
//	(C)IRAI

//	LIBRAIRIE EXEDRV32.LIB pour la conception des driver d'E/S (.DIO) d'EXECPC32


#pragma pack(1)		// Alignement



#include "windows.h"
#include "winbase.h"
#include "memory.h"
#include "string.h"
#include "stdio.h"
#include "io.h"

#include "exec_drv.h"

#include "EXEDRV32.h"

// ***************************************************************************

// Seules les variables ne compromettant pas la rentrance peuvent tre globales

// ***************************************************************************


DWORD gdCountPseudoInstance;	// Compteur d'invocation du driver si plusieurs fois dans la liste

// La taille d'une structure de donnes globales et le nombre de ces structures
// dans le tableau
INFO_PRIVATEDATA gInfo_privatedata;

// Le pointeur sur les n structures de donnes globales (une par pseudo instance de DLL)
BYTE *gp_PrivateData;

char szHelpFile[256];			// Le rpertoire Automgen


// Ces variables globales sont la copie des paramtres reus de l'excuteur EXECPC32

APP_CONTEXT *gpContext;			// Pointe sur les adresse de variables,
								// leur nombre et les pointeurs de fonctions
char *gpFile_ini;				// Un pointeur sur le nom du fichier INI

// Pointeur sur la routine IO interne d'EXECPC32.EXE
DWORD (*io_routine)(DWORD fonction,DWORD *pinp,DWORD *pout,DWORD len);

HINSTANCE hInstance;			// Hinstance de la DLL reue de DllMain(DLL_PROCESS_ATTACH,...)

DWORD gdCurrentPseudoInstance;	// Numro d'invocation du driver si plusieurs fois dans la liste



// ***************************************************************************


// Cette fonction sert  ce que le code de la lidrairie connaisse la taille des
// donnes globales spcifique  1 driver(sous forme de structure) ainsi que leur
// nombre dans leur tableau. Le tableau sert  attribuer des variables globales
//  chaque "instance" de DLL.
extern void *PrivateDataInfo(INFO_PRIVATEDATA *gInfo_privatedata);


extern int drv_init(void *p);
extern int drv_uninit(void *p);
extern int drv_reset(void *p);
extern int drv_watchdog(void *p);
extern int drv_drv_input(void *p);
extern int drv_output(void *p);
extern int drv_rin(void *p);
extern int drv_wou(void *p);

extern int drv_create(void *p);
extern int drv_config(HWND hwnd,LPARAM pNewOldData,DWORD NumDrv);
extern int drv_save_general(void *p);


extern int drv_build(void *p);
extern int drv_destroy(void *p);



// ----------------------------------------------------------------------------------


//DWORD io_routine(DWORD fonction,DWORD *pinp,DWORD *pout,DWORD len)
int inport_b(DWORD port,BYTE *val)
{
return io_routine(INPORTB,(DWORD*)port,(DWORD*)val,0);
}

int outport_b(DWORD port,BYTE val)
{
return io_routine(OUTPORTB,(DWORD*)port,(DWORD*)&val,0);
}

// Fonctions bufferises

int inport_buff(DWORD port,BYTE *val,DWORD len)
{
return io_routine(INPORTBUFF,(DWORD*)port,(DWORD*)val,len);
}

int outport_buff(DWORD port,BYTE *val,DWORD len)
{
return io_routine(OUTPORTBUFF,(DWORD*)port,(DWORD*)val,len);
}

int callKmode(int (*KModeEntry)(void *myArgs),ULONG myArgs)
{
return io_routine(CALLKMODE,(DWORD*)KModeEntry,(DWORD*)myArgs,0);
}

int setKmode(void)
{
return io_routine(SETKMODE,0,0,0);
}

int releaseKmode(void)
{
return io_routine(RELEASEKMODE,0,0,0);
}

// ----------------------------------------------------------------------------------

// Lecture d'un entier depuis une ligne d'un .INI

int get_ini_int(char *cDrvLine,int *iVar,int iDefault)
{
char cBuff[100];
int status = 0;

GetPrivateProfileString(
		INI_DRV_SECTION,	// points to section name 
		cDrvLine,			// points to key name 
		"NU",				// points to default string 
		cBuff,				// points to destination buffer 
		sizeof(cBuff),		// size of destination buffer 
		gpFile_ini	 		// points to initialization filename 
		);

if(strcmp(cBuff,"NU") == 0)
	{
	*iVar = iDefault;
	}
else
	{
	status = sscanf(cBuff,"%d",iVar);
	if((status == 0) || (status == EOF))		// Erreur de conversion ?
		{
		*iVar = iDefault;
		status = -1;
		}
	}
return status;
}

// ----------------------------------------------------------------------------------

// Ecriture d'un entier dans une ligne d'un .INI

int write_ini_int(char *pcKey,DWORD dNumDrv,int iVar)
{
char cBuff[100];
char cKey[100];

strcpy(cKey,pcKey);
sprintf(&cKey[strlen(cKey)],"%d",dNumDrv);

sprintf(cBuff,"%d",iVar);
WritePrivateProfileString(INI_DRV_SECTION,cKey,cBuff,gpFile_ini);

return 0;
}

// ----------------------------------------------------------------------------------


int get_autom_directory(void)
{
char cBuff[256];


szHelpFile[0] = 0;	// Raz chaine rpertoire Autom

GetPrivateProfileString("GENERAL","AUTOMDIR","NU",cBuff,sizeof(cBuff),"AUTOMGEN.INI");
if(strcmp("NU",cBuff) == 0)
	{
	return -1;
	}

strcpy(szHelpFile,cBuff);
strcat(szHelpFile,"\\");
return 0;
}

// -----------------------------------------------------------------

int config(void *pPrivateData,DWORD NumDrv)
{
BYTE *pNewOldData[3];						// Un tableau de pointeurs sur les 2 ci-dessus
HGLOBAL hTab;
BYTE *pSavedData;
int retour;


hTab = GlobalAlloc(GPTR,gInfo_privatedata.wPrivateDataSize * 2);
pSavedData = GlobalLock(hTab);


memcpy(pSavedData,pPrivateData,gInfo_privatedata.wPrivateDataSize);
memcpy(&pSavedData[gInfo_privatedata.wPrivateDataSize],pPrivateData,gInfo_privatedata.wPrivateDataSize);

pNewOldData[0] = pPrivateData;
pNewOldData[1] = pSavedData;
pNewOldData[2] = &pSavedData[gInfo_privatedata.wPrivateDataSize];

retour = drv_config(GetActiveWindow(),(LPARAM)pNewOldData,NumDrv);


GlobalFree(hTab);
return retour;
}


// ****************************************************************************


int __declspec(dllexport) DriverEntry(
				DWORD NumDrv,					// N du driver dans la liste
				int fonction,					// Fonction  excuter
				APP_CONTEXT *app_context,		// Pointeur sur contexte application				
				DRIVER_DATA *gs_execpc_driver,	// Pointeur sur donnes rgissant le driver
				char *ini_name)					// pointeur sur le nom du fichier INI
{
int report;

// Init de VARs globales ne compromettant pas la rentrance
gpContext = app_context;		// Pointeurs systme
gpFile_ini = ini_name;			// Le nom du fichier INI de l'application

// Pointeur sur la routine IO interne d'EXECPC32.EXE
io_routine = gpContext->ptr_io_routine;

// Le N de driver dans la liste de l'excuteur doit tre accessible au cours des
// procdures de fentres par la structure PRIVATE_DATA :
switch(fonction)
	{
	case DRV_INIT:		// Le diver initialise ses priphriques (fopen...)
		{
		BYTE *pPrivateData;
		DWORD *pdNumDrv;

		// Calcul de l'adresse de la structure globale de cette instance
		pPrivateData = &gp_PrivateData[gs_execpc_driver->PseudoInstance * gInfo_privatedata.wPrivateDataSize];		// Les donnes spcifiques
		// Trouver o est le membre DrvNum pour le renseigner
		(BYTE*)pdNumDrv = &pPrivateData[gInfo_privatedata.wOffsetDrvNum];
		*pdNumDrv = NumDrv;

		report = drv_init(pPrivateData);
		}break;

	case DRV_UNINIT:	// Le driver restitue l'tat des priphriques (fclose ...)
		{
		BYTE *pPrivateData;
		DWORD *pdNumDrv;

		pPrivateData = &gp_PrivateData[gs_execpc_driver->PseudoInstance * gInfo_privatedata.wPrivateDataSize];		// Les donnes spcifiques
		// Trouver o est le membre DrvNum pour le renseigner
		(BYTE*)pdNumDrv = &pPrivateData[gInfo_privatedata.wOffsetDrvNum];
		*pdNumDrv = NumDrv;

		report = drv_uninit(pPrivateData);
		}break;

	case DRV_RESET:		// Mise  0 des sorties
		{
		BYTE *pPrivateData;
		DWORD *pdNumDrv;

		pPrivateData = &gp_PrivateData[gs_execpc_driver->PseudoInstance * gInfo_privatedata.wPrivateDataSize];		// Les donnes spcifiques
		// Trouver o est le membre DrvNum pour le renseigner
		(BYTE*)pdNumDrv = &pPrivateData[gInfo_privatedata.wOffsetDrvNum];
		*pdNumDrv = NumDrv;

		report = drv_reset(pPrivateData);
		}break;

	case DRV_INPUT:
		{
		BYTE *pPrivateData;
		DWORD *pdNumDrv;

		pPrivateData = &gp_PrivateData[gs_execpc_driver->PseudoInstance * gInfo_privatedata.wPrivateDataSize];		// Les donnes spcifiques
		// Trouver o est le membre DrvNum pour le renseigner
		(BYTE*)pdNumDrv = &pPrivateData[gInfo_privatedata.wOffsetDrvNum];
		*pdNumDrv = NumDrv;

		report = drv_watchdog(pPrivateData);
		if(report >= 0)
			report = drv_input(pPrivateData);
		}break;

	case DRV_OUTPUT:
		{
		BYTE *pPrivateData;
		DWORD *pdNumDrv;

		pPrivateData = &gp_PrivateData[gs_execpc_driver->PseudoInstance * gInfo_privatedata.wPrivateDataSize];		// Les donnes spcifiques
		// Trouver o est le membre DrvNum pour le renseigner
		(BYTE*)pdNumDrv = &pPrivateData[gInfo_privatedata.wOffsetDrvNum];
		*pdNumDrv = NumDrv;

		report = drv_output(pPrivateData);
		}break;

	case DRV_RIN:
		{
		BYTE *pPrivateData;
		DWORD *pdNumDrv;

		pPrivateData = &gp_PrivateData[gs_execpc_driver->PseudoInstance * gInfo_privatedata.wPrivateDataSize];		// Les donnes spcifiques
		// Trouver o est le membre DrvNum pour le renseigner
		(BYTE*)pdNumDrv = &pPrivateData[gInfo_privatedata.wOffsetDrvNum];
		*pdNumDrv = NumDrv;

		report = drv_rin(pPrivateData);
		}break;

	case DRV_WOU:
		{
		BYTE *pPrivateData;
		DWORD *pdNumDrv;

		pPrivateData = &gp_PrivateData[gs_execpc_driver->PseudoInstance * gInfo_privatedata.wPrivateDataSize];		// Les donnes spcifiques
		// Trouver o est le membre DrvNum pour le renseigner
		(BYTE*)pdNumDrv = &pPrivateData[gInfo_privatedata.wOffsetDrvNum];
		*pdNumDrv = NumDrv;

		report = drv_wou(pPrivateData);
		}break;

	case DRV_CREATE:	// Le driver s'alloue la mmoire ncessaire sans lecture du .INI
		{				// car celui-ci n'est pas encore document
		BYTE *pPrivateData;
		DWORD *pdNumDrv;
		
		if(gdCountPseudoInstance < gInfo_privatedata.wMaxPseudoInstance)
			{
			gs_execpc_driver->PseudoInstance = gdCountPseudoInstance;
			pPrivateData = &gp_PrivateData[gs_execpc_driver->PseudoInstance * gInfo_privatedata.wPrivateDataSize];	// Les donnes spcifiques

			// Trouver o est le membre DrvNum pour le renseigner
			(BYTE*)pdNumDrv = &pPrivateData[gInfo_privatedata.wOffsetDrvNum];
			*pdNumDrv = NumDrv;

			report = drv_create(pPrivateData);
			if(report > -1)
				gdCountPseudoInstance++;
			}
		else
			report = -1;

		}break;


	case DRV_CONFIG:	// Le driver modifie ses paramtres
		{
		BYTE *pPrivateData;
		DWORD *pdNumDrv;

		gdCurrentPseudoInstance = gs_execpc_driver->PseudoInstance;
		pPrivateData = &gp_PrivateData[gdCurrentPseudoInstance * gInfo_privatedata.wPrivateDataSize];		// Les donnes spcifiques

		// Trouver o est le membre DrvNum pour le renseigner
		(BYTE*)pdNumDrv = &pPrivateData[gInfo_privatedata.wOffsetDrvNum];
		*pdNumDrv = NumDrv;

		report = config(pPrivateData,NumDrv);
		}break;

	case DRV_SAVE:		// Le driver crit ses propres parties de la section [execpc32_drvio]
		{
		BYTE *pPrivateData;
		DWORD *pdNumDrv;

		pPrivateData = &gp_PrivateData[gs_execpc_driver->PseudoInstance * gInfo_privatedata.wPrivateDataSize];		// Les donnes spcifiques
		// Trouver o est le membre DrvNum pour le renseigner
		(BYTE*)pdNumDrv = &pPrivateData[gInfo_privatedata.wOffsetDrvNum];
		*pdNumDrv = NumDrv;

		report = drv_save(pPrivateData);
		}break;

	// Le driver documente le poste PRIVATE_DATA[pseudo instance] avec des inits du .INI
	// Le driver fait des allocations chaines si ncessaire et y copie des inits
	case DRV_BUILD:
		{
		BYTE *pPrivateData;
		DWORD *pdNumDrv;		

		if(gdCountPseudoInstance < gInfo_privatedata.wMaxPseudoInstance)
			{
			gs_execpc_driver->PseudoInstance = gdCountPseudoInstance;
			pPrivateData = &gp_PrivateData[gs_execpc_driver->PseudoInstance * gInfo_privatedata.wPrivateDataSize];	// Les donnes spcifiques

			// Trouver o est le membre DrvNum pour le renseigner
			(BYTE*)pdNumDrv = &pPrivateData[gInfo_privatedata.wOffsetDrvNum];
			*pdNumDrv = NumDrv;

			report = drv_build(pPrivateData);
			if(report > -1)
				gdCountPseudoInstance++;
			}
		else
			report = -1;

		}break;

	case DRV_DESTROY:	// Le driver supprime les allocations faites par DRV_BUILD
		{
		BYTE	*pPrivateData;
		DWORD *pdNumDrv;
		DWORD	i;
		DWORD	dwPseudoInstance;		// N du poste dans la table de structures
		WORD	wPrivateDataSize;		// Taille des donnes globales d'une instance de driver

		// Pseudo instance du driver  supprimer
		dwPseudoInstance = gs_execpc_driver->PseudoInstance;
		// Taille des donnes globales d'une instance de driver
		wPrivateDataSize = gInfo_privatedata.wPrivateDataSize;

		pPrivateData = &gp_PrivateData[dwPseudoInstance * wPrivateDataSize];		// Les donnes spcifiques
		// Trouver o est le membre DrvNum pour le renseigner
		(BYTE*)pdNumDrv = &pPrivateData[gInfo_privatedata.wOffsetDrvNum];
		*pdNumDrv = NumDrv;


		report = drv_destroy(pPrivateData);

		if(gdCountPseudoInstance != 0)
			gdCountPseudoInstance--;	// Une Pseudo instance de moins

		if(gdCountPseudoInstance != 0)
			{
			for(i=dwPseudoInstance;i<gdCountPseudoInstance;i++)
				{
				memmove(&gp_PrivateData[i*wPrivateDataSize],&gp_PrivateData[(i+1)*wPrivateDataSize],wPrivateDataSize);
				}
			}

		}break;


	default:
		{
		report = -1;		// Fonction indfinie
		}break;

	}
return report;
}

// -----------------------------------------------------------------


// Ce code sert uniquement  rcuprer l'instance de la DLL

BOOL WINAPI DllMain(HINSTANCE hInst,DWORD dwReason,LPVOID lpReserved)
{
switch(dwReason)
	{
	case DLL_PROCESS_ATTACH :
		{
		hInstance = hInst;			// Instance de la DLL
		gdCountPseudoInstance = 0;


		gp_PrivateData = drv_PrivateDataInfo(&gInfo_privatedata);

		get_autom_directory();		// Connaitre le rpertoire (pour HELP FILE)
		strcat(szHelpFile,gInfo_privatedata.pszHelFileName);	// Ajout du .HLP

		// Reset des structures globales
		memset(gp_PrivateData,0,(gInfo_privatedata.wPrivateDataSize*gInfo_privatedata.wMaxPseudoInstance));


		} break;

	case DLL_THREAD_ATTACH :
		{
		hInstance = hInst;			// Instance de la DLL
		} break;


	case DLL_PROCESS_DETACH :
		{
		} break;
	}
return TRUE;
}


// -----------------------------------------------------------------


// Contrle de la validit d'un numro de variable

BOOL ValidNumVar(WORD num,WORD used,int type)
{
// Si pas de programme dans l'API : aucun contrle de borne possible
if(gpContext->fApp_ok == FALSE)
	return TRUE;


switch(type)
	{
	case INP_TYPE:
		{
		if((num + used) > gpContext->nbinput)
			return FALSE;		
		}break;

	case OUT_TYPE:
		{
		if((num + used) > gpContext->nboutput)
			return FALSE;
		}break;

	case BIT_TYPE:
		{
		if((num + used) > gpContext->nbbit)
			return FALSE;
		}break;

	case WORD_TYPE:
		{
		if((num + used) > gpContext->nbword)
			return FALSE;
		}break;

	case COUNT_TYPE:
		{
		if((num + used) > gpContext->nbcount)
			return FALSE;
		}break;

	case FLOAT_TYPE:
		{
		if((num + used) > gpContext->nbfloat)
			return FALSE;
		}break;

	case LONG_TYPE:
		{
		if((num + used) > gpContext->nblong)
			return FALSE;
		}break;


	default:
		{
		return FALSE;	// Type de variable inconnu
		}

	}

return TRUE;
}



// ****************************************************************************



